(function() {
    var expayHasAnyBankSelected = function expayHasAnyBankSelected() {
        return !!$('[name="expay-payment-method"]:visible').filter(":checked").length;
    };

    var isExpayOptionSelected = function isExpayOptionSelected() {
        return !!$('[name="expay-payment-category"]').filter(":checked").length
    };

    function expayAlert(message, status) {
        swal(message, "", status);
    }

    let validator = function validator() {
        var attrs = $('.attribute:visible');
        if (!attrs) {
            return true;
        }

        let result = true;
        attrs.each(function() {
            var $item = $(this),
                regText = $item.data('regexp') + '';

            if (regText) {
                result = (new RegExp(regText)).test($item.val());
            } else if ($item.data('required')) {
                result = !!$item.val();
            }

            if (!$item.val() && $item.prop('required')) {
                $item.addClass('invalid');
                expayAlert("Required field is empty!", "error");
                return false;
            }

            if (!result) {
                if ($item.val()) {
                    $item.addClass('invalid');
                    expayAlert("Invalid value of field!", "error");
                    return false;
                } else {
                    result = true;
                }
            }
        });
        return result;
    };

    $(function() {
        let $paymentConfirmationButton = $('#place_order');

        $('.attribute').on('click', function() {
            $(this).removeClass('invalid');
        });

        $('.payment-method-radio').on('change', function () {
            ($('.attribute')).prop('disabled', 'disabled');
            if ($(this).is(':checked')) {
                ($(this).siblings('.attribute-list')).children('.attribute').prop('disabled', false);
            }
        });

        $paymentConfirmationButton.on('click', function(event) {
            let $canProceed = true;

            if (!isExpayOptionSelected()) {
                $canProceed = false;
            }

            if ($canProceed && !expayHasAnyBankSelected()) {
                expayAlert("Please select expay bank before continuing!", "error");
                $canProceed = false;
            }

            if ($canProceed && !validator()) {
                $canProceed = false;
            }

            if (!$canProceed) {
                event.preventDefault();
                event.stopPropagation();
            }
        });
    });
})();